'From Squeak3.4alpha of ''11 November 2002'' [latest update: #5109] on 18 November 2002 at 8:27:50 pm'!
"Change Set:		SystemWindowIcons-nk
Date:			18 November 2002
Author:			Ned Konz

This change set makes the window close and collapse icons independent of the existence of the ComicBold font.
"!

MorphicModel subclass: #SystemWindow
	instanceVariableNames: 'labelString stripes label closeBox collapseBox activeOnlyOnTop paneMorphs paneRects collapsedFrame fullFrame isCollapsed menuBox mustNotClose labelWidgetAllowance updatablePanes allowReframeHandles labelArea expandBox '
	classVariableNames: 'CloseBoxImage CollapseBoxImage TopWindow '
	poolDictionaries: ''
	category: 'Morphic-Windows'!

!SystemWindow methodsFor: 'initialization' stamp: 'nk 11/18/2002 20:25'!
addCloseBox
	"If I have a labelArea, add a close box to it"

	| frame |
	labelArea ifNil: [^ self].
	closeBox _ IconicButton new target: self;
		 actionSelector: #closeBoxHit;
		 labelGraphic: self class closeBoxImage;
		 color: Color transparent;
		 extent: 14@14;
		 borderWidth: 0;
		setBalloonText: 'close this window'.
	frame _ LayoutFrame new.
	frame leftFraction: 0; leftOffset: 4; topFraction: 0; topOffset: 1.
	closeBox layoutFrame: frame.
	labelArea addMorph: closeBox.! !

!SystemWindow methodsFor: 'initialization' stamp: 'nk 11/18/2002 20:24'!
initialize
	"Initialize a system window.  Add label, stripes, etc., if desired"

	| |
	super initialize.
	allowReframeHandles := true.
	labelString ifNil: [labelString _ 'Untitled Window'].
	isCollapsed _ false.
	activeOnlyOnTop _ true.
	paneMorphs _ Array new.
	Preferences alternativeWindowLook ifFalse:[
		borderColor _ Color black.
		borderWidth _ 1.
		color _ Color black.
	] ifTrue:[
		borderColor _ #raised.
		borderWidth _ 2.
		color _ Color white.
	].
	self layoutPolicy: ProportionalLayout new.

	self wantsLabel ifTrue:
		[label _ StringMorph new contents: labelString;
				font: Preferences windowTitleFont emphasis: 1.

		"Add collapse box so #labelHeight will work"
		collapseBox _ IconicButton new target: self;
				 actionSelector: #collapseOrExpand;
				 labelGraphic: self class collapseBoxImage;
				 color: Color transparent;
				 extent: 14@14;
				setBalloonText: 'collapse this window';
				 borderWidth: 0.
		stripes _ Array with: (RectangleMorph newBounds: bounds)  "see extent:"
					with: (RectangleMorph newBounds: bounds).

		self addLabelArea.

		labelArea addMorph: (stripes first borderWidth: 1).
		labelArea addMorph: (stripes second borderWidth: 2).
		self setLabelWidgetAllowance.
		self addCloseBox.
		self addMenuControl.
		labelArea addMorph: label.
		self wantsExpandBox ifTrue: [self addExpandBox].
		labelArea addMorph: collapseBox.

		self setFramesForLabelArea.
		Preferences clickOnLabelToEdit ifTrue:
			[label on: #mouseDown send: #relabel to: self].
		Preferences noviceMode ifTrue:
			[closeBox ifNotNil: [closeBox setBalloonText: 'close window'].
			menuBox ifNotNil: [menuBox setBalloonText: 'window menu'].
			collapseBox ifNotNil: [collapseBox setBalloonText: 'collapse/expand window']]].
	self on: #mouseEnter send: #spawnReframeHandle: to: self.
	self on: #mouseLeave send: #spawnReframeHandle: to: self.

	self extent: 300@200.
	mustNotClose _ false.
	updatablePanes _ Array new.! !


!SystemWindow class methodsFor: 'instance creation' stamp: 'nk 11/18/2002 20:20'!
closeBoxImage
	"Supplied here because we don't necessarily have ComicBold"

	^ CloseBoxImage ifNil: [CloseBoxImage _ (Form
	extent: 9@9
	depth: 16
	fromArray: #( 65537 0 0 1 65536 65537 65536 0 65537 65536 1 65537 1 65537 0 0 65537 65537 65536 0 0 1 65537 0 0 0 65537 65537 65536 0 1 65537 1 65537 0 65537 65536 0 65537 65536 65537 0 0 1 65536)
	offset: 0@0)]! !

!SystemWindow class methodsFor: 'instance creation' stamp: 'nk 11/18/2002 20:21'!
collapseBoxImage
	"Supplied here because we don't necessarily have ComicBold"

	^ CollapseBoxImage ifNil: [ CollapseBoxImage _ (Form
	extent: 10@10
	depth: 16
	fromArray: #( 0 131074 131074 131074 0 2 131074 131074 131074 131072 131074 131072 0 2 131074 131074 0 0 0 131074 131074 0 0 0 131074 131074 0 0 0 131074 131074 0 0 0 131074 131074 131072 0 2 131074 2 131074 131074 131074 131072 0 131074 131074 131074 0)
	offset: 0@0)]! !

